searchData={"items":[{"type":"module","title":"ExTimer","doc":"ExTimer module.","ref":"ExTimer.html"},{"type":"function","title":"ExTimer.add/3","doc":"add new timer to send msg after time milliseconds.","ref":"ExTimer.html#add/3"},{"type":"function","title":"Examples - ExTimer.add/3","doc":"```elixir\r\niex> now_ref = fn -> 500 end\r\niex> timer = ExTimer.new(now_ms: now_ref)\r\n%ExTimer{now_ms: now_ref, timers: []}\r\niex> timer = ExTimer.add(timer, {:handler, :name, \"uhaha\"}, 2000)\r\n%ExTimer{now_ms: now_ref, timers: [%ExTimer.Node{due_ms: 2500, msg: {:handler, :name, \"uhaha\"}}]}\r\niex> [timer_node] = timer.timers\r\n[%ExTimer.Node{due_ms: 2500, msg: {:handler, :name, \"uhaha\"}}]\r\niex> timer_node.msg == {:handler, :name, \"uhaha\"}\r\ntrue\r\niex> timer_node.due_ms == 2500\r\ntrue\r\n\r\n```","ref":"ExTimer.html#add/3-examples"},{"type":"macro","title":"ExTimer.clear/3","doc":"delete all the registerd timers.","ref":"ExTimer.html#clear/3"},{"type":"macro","title":"Examples - ExTimer.clear/3","doc":"```elixir\r\niex> state = %{}\r\niex> now_ref = fn -> 500 end\r\niex> timer = ExTimer.new(now_ms: now_ref)\r\niex> timer = ExTimer.add(timer, {:handler, :name, \"uhaha\"}, 2000)\r\n%ExTimer{timers: [%ExTimer.Node{due_ms: 2500, msg: {:handler, :name, \"uhaha\"}}], now_ms: now_ref}\r\niex> {_state, _timer} = ExTimer.clear(state, timer)\r\n{%{}, %ExTimer{timers: [], now_ms: now_ref}}\r\n```","ref":"ExTimer.html#clear/3-examples"},{"type":"function","title":"ExTimer.exist?/2","doc":"return true if found the timer at the given msg, otherwise return false","ref":"ExTimer.html#exist?/2"},{"type":"function","title":"Examples - ExTimer.exist?/2","doc":"```elixir\r\niex> timer = %ExTimer{timers: [%ExTimer.Node{msg: {:handler, :name, \"uhaha\"}, due_ms: 2000}]}\r\niex> ExTimer.exist?(timer, {:handler, :name, \"uhaha\"})\r\ntrue\r\n\r\n```","ref":"ExTimer.html#exist?/2-examples"},{"type":"function","title":"ExTimer.get_next_expiration/2","doc":"get the minimum time(milliseconds) for the timer to expired.","ref":"ExTimer.html#get_next_expiration/2"},{"type":"function","title":"Examples - ExTimer.get_next_expiration/2","doc":"```elixir\r\n\r\ndef handle_info({:tick}, state) do\r\n  ...\r\n  {state, timer} = ExTimer.update(state, state.timer)\r\n  state = put_in(state.timer, timer)\r\n  ...\r\n  Process.send_after(self(), {:tick}, ExTimer.get_next_expiration(state.timer, 1000))\r\n  {:noreply, state}\r\nend\r\n```","ref":"ExTimer.html#get_next_expiration/2-examples"},{"type":"function","title":"ExTimer.new/1","doc":"","ref":"ExTimer.html#new/1"},{"type":"function","title":"ExTimer.remove/2","doc":"delete the previous registerd timer.","ref":"ExTimer.html#remove/2"},{"type":"function","title":"Examples - ExTimer.remove/2","doc":"```elixir\r\niex> timer = %{timers: [%ExTimer.Node{msg: {:handler, :name, \"uhaha\"}, due_ms: 2000}]}\r\niex> ExTimer.remove(timer, {:handler, :name, \"uhaha\"})\r\n%{timers: []}\r\n\r\n```","ref":"ExTimer.html#remove/2-examples"},{"type":"macro","title":"ExTimer.update/2","doc":"call the callback handler (handle_timer) for the timer that has elapsed.","ref":"ExTimer.html#update/2"},{"type":"macro","title":"Examples - ExTimer.update/2","doc":"```\r\ndef handle_timer({:tick}, state) do\r\n  ...\r\n  {state, timer} = ExTimer.update(state, state.timer)\r\n  state = put_in(state.timer, timer)\r\n  ...\r\n  {state, timer}\r\nend\r\n```","ref":"ExTimer.html#update/2-examples"},{"type":"type","title":"ExTimer.state/0","doc":"","ref":"ExTimer.html#t:state/0"},{"type":"type","title":"ExTimer.t/0","doc":"","ref":"ExTimer.html#t:t/0"},{"type":"type","title":"ExTimer.time_ms/0","doc":"","ref":"ExTimer.html#t:time_ms/0"},{"type":"type","title":"ExTimer.timer_node/0","doc":"","ref":"ExTimer.html#t:timer_node/0"},{"type":"type","title":"ExTimer.timer_node_msg/0","doc":"","ref":"ExTimer.html#t:timer_node_msg/0"},{"type":"module","title":"ExTimer.Node","doc":"","ref":"ExTimer.Node.html"},{"type":"type","title":"ExTimer.Node.msg/0","doc":"","ref":"ExTimer.Node.html#t:msg/0"},{"type":"type","title":"ExTimer.Node.t/0","doc":"","ref":"ExTimer.Node.html#t:t/0"},{"type":"type","title":"ExTimer.Node.time_ms/0","doc":"","ref":"ExTimer.Node.html#t:time_ms/0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}